# $Id: Exception.pm,v 1.8 2000/08/06 12:15:04 matt Exp $

package Apache::AxKit::Exception;
use strict;
use vars qw/@ISA @EXPORT $AUTOLOAD/;
use Exporter;
@ISA = ('Exporter');
@EXPORT = ('die');
           
sub import {
	my $pkg = shift;
#	$pkg->export('CORE::GLOBAL', 'die');
	Exporter::import($pkg,@_,'die');
}

sub die (@) {
	if (!ref($_[0])) {
		CORE::die Apache::AxKit::Exception->Error(text => join('', @_));
	}
	CORE::die @_;
}

sub AUTOLOAD {
	no strict 'refs', 'subs';
	if ($AUTOLOAD =~ /.*::([A-Z]\w+)$/) {
		my $exception = $1;
		*{$AUTOLOAD} = 
			sub {
				shift; 
				my ($package, $filename, $line) = caller;
				push @_, 'caller' => {
								'package' => $package,
								'filename' => $filename,
								'line' => $line,
									};
				bless { @_ }, "Apache::AxKit::Exception::$exception"; 
			};
		goto &{$AUTOLOAD};
	}
	else {
		Apache::AxKit::Exception::die("No such exception class: $AUTOLOAD\n");
	}
}

sub Init {
# 	$SIG{__DIE__} = sub {
# 		if(!ref($_[0])) {
# 			die Apache::AxKit::Exception->Error(text => join('', @_));
# 		}
# 		die @_;
# 	};
}

package Apache::AxKit::Exception::Error;
use overload '""' => \&str;

sub str {
	shift->{text};
}

1;
